'use strict';

/* eslint-disable newline-per-chained-call */
const bhttp = require('bhttp');
const cheerio = require('cheerio');
const moment = require('moment');

async function getPhotos(entryId, site) {
    const { hostname } = new URL(site.url);

    const res = await bhttp.get(`https://${hostname}/gallery.php?type=highres&id=${entryId}`);
    const html = res.body.toString();

    const $ = cheerio.load(html, { normalizeWhitespace: true });
    const photos = $('a.fakethumb').map((photoIndex, photoElement) => $(photoElement).attr('data-src') || $(photoElement).attr('href')).toArray();

    return photos;
}

function scrapeLatest(html, site) {
    const $ = cheerio.load(html, { normalizeWhitespace: true });
    const sceneElements = $('.content-wrapper .scene').toArray();

    return sceneElements.map((element) => {
        const sceneLinkElement = $(element).find('h3 a');

        const url = sceneLinkElement.attr('href');
        const title = sceneLinkElement.text();
        const entryId = url.split('/').slice(-1)[0];

        const date = moment.utc($(element).find('.scene-date'), 'MM/DD/YYYY').toDate();

        const actors = $(element).find('.scene-models a').map((actorIndex, actorElement) => $(actorElement).text()).toArray();
        const likes = Number($(element).find('.scene-votes').text());

        const thumbnailElement = $(element).find('img.img-responsive');
        const photoCount = Number(thumbnailElement.attr('thumbs_num'));
        const poster = thumbnailElement.attr('src');
        const photos = Array.from({ length: photoCount }, (val, index) => thumbnailElement.attr(`src${index + 1}`));

        const scene = {
            url,
            entryId,
            title,
            actors,
            date,
            poster,
            photos,
            rating: {
                likes,
            },
            site,
        };

        return scene;
    });
}

async function scrapeScene(html, url, site) {
    const $ = cheerio.load(html, { normalizeWhitespace: true });
    const release = {};

    [release.entryId] = url.split('/').slice(-1);
    release.title = $('.video-wrapper meta[itemprop="name"]').attr('content');
    release.description = $('.video-wrapper meta[itemprop="description"]').attr('content');

    release.date = moment.utc($('.video-wrapper meta[itemprop="uploadDate"]').attr('content'), 'MM/DD/YYYY').toDate();
    release.actors = $('.content-wrapper .scene-models-list a').map((actorIndex, actorElement) => $(actorElement).text()).toArray();

    const timestamp = $('.video-wrapper meta[itemprop="duration"]').attr('content');

    if (timestamp) {
        const [minutes, seconds] = timestamp.match(/\d+/g);
        release.duration = Number(minutes) * 60 + Number(seconds);
    }

    release.tags = $('.content-desc .scene-tags a').map((tagIndex, tagElement) => $(tagElement).text()).toArray();
    release.likes = Number($('.content-desc #social-actions #likes').text());

    const posterScript = $('script:contains(poster)').html();
    const posterLink = posterScript.slice(posterScript.indexOf('https://'), posterScript.indexOf('.jpg') + 4);
    release.poster = $('meta[property="og:image"]').attr('content') || posterLink;

    release.trailer = {
        src: $('meta[property="og:video"]').attr('content') || $('#videojs-trailer source').attr('src'),
    };

    release.photos = await getPhotos(release.entryId, site);
    release.movie = $('a[data-track="FULL MOVIE"]').attr('href');

    const siteElement = $('.content-wrapper .logos-sites a');
    if (siteElement) release.channel = siteElement.text().replace(/\s+/g, '').toLowerCase();

    return release;
}

async function fetchLatest(site, page = 1) {
    const { hostname } = new URL(site.url);

    if (hostname.match('private.com')) {
        const res = await bhttp.get(`${site.url}/${page}/`);

        return scrapeLatest(res.body.toString(), site);
    }

    const res = await bhttp.get(`${site.url}/scenes/${page}/`);

    return scrapeLatest(res.body.toString(), site);
}

async function fetchScene(url, site) {
    const res = await bhttp.get(url);

    return scrapeScene(res.body.toString(), url, site);
}

module.exports = {
    fetchLatest,
    fetchScene,
};
